> For the complete documentation index, see [llms.txt](https://docs.earthscale.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.earthscale.ai/earthscale-documentation/advanced-dataset-configuration.md).

# Raster Mosaic and Time Series Support

Earthscale provides native support for tiled, multi-file raster datasets. Some examples of these dataset types:

* Each file has a different projection (e.g., UTM zone)
* Each file represents a separate band
* Each file has a datetime encoded in the filename

By "native support", we mean that we can take a collection of these files and *represent them as a single dataset* with multiple bands, projections, and time steps. In our web app, you can then configure multi-band visualizations or toggle through time. And you can use our export functionality to download slices of this data in a single projection.

## ImageDataset Configuration

For multi-file GeoTIFF datasets (using wildcard patterns like `gs://bucket/path/*.tif`), the following configuration options are available:

### Filename Date Pattern

Extract timestamps from your filenames to enable temporal queries on your dataset. Use [Python strptime format codes](https://docs.python.org/3/library/datetime.html#strftime-and-strptime-format-codes).

**Examples:**

| Filename Example                   | Pattern             |
| ---------------------------------- | ------------------- |
| `data_2024-01-15.tif`              | `%Y-%m-%d`          |
| `tile_20240115_v2.tif`             | `%Y%m%d`            |
| `2024/01/15/image.tif`             | `%Y/%m/%d/`         |
| `sentinel_2024-01-15T10:30:00.tif` | `%Y-%m-%dT%H:%M:%S` |

**Common format codes:**

| Code | Meaning        | Example |
| ---- | -------------- | ------- |
| `%Y` | 4-digit year   | 2024    |
| `%m` | 2-digit month  | 01-12   |
| `%d` | 2-digit day    | 01-31   |
| `%H` | Hour (24-hour) | 00-23   |
| `%M` | Minute         | 00-59   |
| `%S` | Second         | 00-59   |
| `%j` | Day of year    | 001-366 |

### Filename Band Patterns

Map filename patterns to band names when your bands are stored in separate files.

This is useful when you have files like:

* `tile_B02.tif`, `tile_B03.tif`, `tile_B04.tif`
* `scene_red.tif`, `scene_green.tif`, `scene_blue.tif`

**Configuration format:**

For each pattern, specify:

1. **Pattern**: A wildcard pattern including the substring that appears in filenames for that band
2. **Band Name**: The name to assign to that band

**Examples:**

| Filename Pattern | Band Name |
| ---------------- | --------- |
| `*_B02*`         | `blue`    |
| `*_B03*`         | `green`   |
| `*_B04*`         | `red`     |
| `*_B08*`         | `nir`     |

Or for descriptive filenames:

| Filename Pattern | Band Name |
| ---------------- | --------- |
| `*_red*`         | `red`     |
| `*_green*`       | `green`   |
| `*_blue*`        | `blue`    |

This can optionally be combined with the filename date pattern argument.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.earthscale.ai/earthscale-documentation/advanced-dataset-configuration.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
